
/*
 * Copyright (C) 2003-2005 Archie L. Cobbs and others.
 * All rights reserved.
 * 
 * This file is part of the JC virtual machine software.
 * 
 * JC is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License,
 * or (at your option) any later version.
 * 
 * JC is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General
 * Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with JC in the file "LGPL-2.1"; if not, write to:
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * $Id: jc_invoke.h,v 1.1 2005/01/13 04:44:59 archiecobbs Exp $
 */

/*
 * VM printer function type.
 */
typedef int	_jc_printer(FILE *stream, const char *fmt, va_list args);

/*
 * Return values from _jc_invoke()
 */
#define _JC_RETURN_NORMAL	0		/* normal return */
#define _JC_RETURN_EXCEPTION	1		/* exception thrown */
#define _JC_RETURN_ERROR	2		/* error during startup */

/*
 * Invoke the JC Java virtual machine.
 */
extern int	_jc_invoke(int ac, const char **av,
			int ignoreUnrecognized, _jc_printer *printer);

