
/*
 * Copyright (C) 2003-2005 Archie L. Cobbs and others.
 * All rights reserved.
 * 
 * This file is part of the JC virtual machine software.
 * 
 * JC is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License,
 * or (at your option) any later version.
 * 
 * JC is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General
 * Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with JC in the file "LGPL-2.1"; if not, write to:
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * $Id: jni_machdep.h,v 1.1.1.1 2004/02/20 05:15:11 archiecobbs Exp $
 */

#ifndef _JNI_MACHDEP_H_
#define _JNI_MACHDEP_H_

/*
 * Goal: define JNI C typedefs for Java primitive types.
 */

#if (defined (__ia64__) || defined (__alpha__) || defined (__i386__) || defined(__sparc__))

typedef	unsigned char	jboolean;
typedef	signed char	jbyte;
typedef	unsigned short	jchar;
typedef	signed short	jshort;
typedef	signed int	jint;
typedef	long long	jlong;
typedef float		jfloat;
typedef double		jdouble;

#else
#error "Unsupported architecture"
#endif

#endif	/* _JNI_MACHDEP_H_ */
