
//
// Copyright (C) 2003-2005 Archie L. Cobbs and others.
// All rights reserved.
// 
// This file is part of the JC virtual machine software.
// 
// JC is free software; you can redistribute it and/or modify it under
// the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License,
// or (at your option) any later version.
// 
// JC is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General
// Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with JC in the file "LGPL-2.1"; if not, write to:
// Free Software Foundation, Inc., 59 Temple Place, Suite 330,
// Boston, MA 02111-1307, USA.
//
// $Id: Constants.java,v 1.1.1.1 2004/02/20 05:15:25 archiecobbs Exp $
//

package org.dellroad.jc.cgen;

/**
 * Constants that define the sizes of certain automatically
 * generated hash tables used by generated C code.
 */
public interface Constants {
	/**
	 * Size of interface method lookup hash tables
	 * and ``quick'' interface method lookup tables.
	 * Must be a power of two and equal to the definition
	 * in <code>jc_defs.h</code>.
	 */
	public static final int IMETHOD_HASHSIZE = 128;

	/**
	 * Size of instanceof hash tables.
	 * Must be a power of two and equal to the definition
	 * in <code>jc_defs.h</code>.
	 */
	public static final int INSTANCEOF_HASHSIZE = 128;
}

