
//
// Copyright (C) 2003-2005 Archie L. Cobbs and others.
// All rights reserved.
// 
// This file is part of the JC virtual machine software.
// 
// JC is free software; you can redistribute it and/or modify it under
// the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License,
// or (at your option) any later version.
// 
// JC is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General
// Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with JC in the file "LGPL-2.1"; if not, write to:
// Free Software Foundation, Inc., 59 Temple Place, Suite 330,
// Boston, MA 02111-1307, USA.
//
// $Id: StackAlloc.java,v 1.2 2004/12/17 15:35:46 archiecobbs Exp $
//

package org.dellroad.jc.cgen.escape;

import java.util.*;
import soot.*;
import soot.jimple.*;

/**
 * Holds information about a potential stack-allocatable 'new' statement.
 */
class StackAlloc {

	AssignStmt stmt;
	Local local;
	Value value;		// the 'new' expression
	Boolean escapes; 	// TRUE = yes, FALSE = no, null = unknown
	int size;
	int cost;

	public StackAlloc(Stmt ostmt) {
		this.stmt = (AssignStmt)ostmt;
		this.local = (Local)stmt.getLeftOp();
		this.value = stmt.getRightOp();
	}
}

