
//
// Copyright (C) 2003-2005 Archie L. Cobbs and others.
// All rights reserved.
// 
// This file is part of the JC virtual machine software.
// 
// JC is free software; you can redistribute it and/or modify it under
// the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License,
// or (at your option) any later version.
// 
// JC is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General
// Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with JC in the file "LGPL-2.1"; if not, write to:
// Free Software Foundation, Inc., 59 Temple Place, Suite 330,
// Boston, MA 02111-1307, USA.
//
// $Id: StackAllocTag.java,v 1.3 2005/02/20 21:14:31 archiecobbs Exp $
//

package org.dellroad.jc.cgen.escape;

import soot.tagkit.Tag;

/**
 * Tag for stack-allocatable allocations.
 */
public class StackAllocTag implements Tag {

	private final static String NAME = "StackAllocTag";

	int id;

	public StackAllocTag(int id) {
		this.id = id;
	}

	public int getId() {
		return id;
	}

	public byte[] getValue() {
		return new byte[] {
		    (byte)(id >> 24), (byte)(id >> 16),
		    (byte)(id >> 8), (byte)id
		};
	}

	public String getName() {
		return NAME;
	}

	public String toString() {
		return NAME;
	}
}

