
/*
 * Copyright (C) 2003-2005 Archie L. Cobbs and others.
 * All rights reserved.
 * 
 * This file is part of the JC virtual machine software.
 * 
 * JC is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License,
 * or (at your option) any later version.
 * 
 * JC is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General
 * Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with JC in the file "LGPL-2.1"; if not, write to:
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * $Id: main.c,v 1.2 2005/01/13 04:44:59 archiecobbs Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include "jc_invoke.h"

int
main(int ac, char **av)
{
	int status = 0;

	/* Invoke the JC VM */
	switch (_jc_invoke(ac, (const char **)av, 1, vfprintf)) {
	case _JC_RETURN_NORMAL:
		break;
	case _JC_RETURN_ERROR:
	case _JC_RETURN_EXCEPTION:
		status = 1;
		break;
	}

	/* Done */
	return status;
}

