
/*
 * Copyright (C) 2003-2005 Archie L. Cobbs and others.
 * All rights reserved.
 * 
 * This file is part of the JC virtual machine software.
 * 
 * JC is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License,
 * or (at your option) any later version.
 * 
 * JC is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General
 * Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with JC in the file "LGPL-2.1"; if not, write to:
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * $Id: i386_structures.h,v 1.1.1.1 2004/02/20 05:15:49 archiecobbs Exp $
 */

#ifndef _ARCH_I386_STRUCTURES_H_
#define _ARCH_I386_STRUCTURES_H_

/*
 * i386 stack frame:
 *
 *	| ...         |
 *	+-------------+
 *	| param2      |
 *	+-------------+
 *	| param1      |
 *	+-------------+
 *	| param0      |
 *	+-------------+
 *	| return addr |
 *	+-------------+
 *	| saved %epb  |    <== %ebp
 *	+-------------+
 *	| locals...   |
 *
 * So all we need is a pointer to the saved %epb register.
 */

typedef _jc_word	*_jc_stack_frame;	/* pointer to saved %epb */

#endif	/* _ARCH_I386_STRUCTURES_H_ */

