
/*
 * Copyright (C) 2003-2005 Archie L. Cobbs and others.
 * All rights reserved.
 * 
 * This file is part of the JC virtual machine software.
 * 
 * JC is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License,
 * or (at your option) any later version.
 * 
 * JC is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General
 * Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with JC in the file "LGPL-2.1"; if not, write to:
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * $Id: java_io_VMObjectStreamClass.c,v 1.4 2005/05/15 21:41:01 archiecobbs Exp $
 */

#include "libjc.h"
#include "java_io_VMObjectStreamClass.h"

/*
 * static final native boolean hasClassInitializer(Class)
 */
jboolean _JC_JCNI_ATTR
JCNI_java_io_VMObjectStreamClass_hasClassInitializer(_jc_env *env,
	_jc_object *class)
{
	_jc_jvm *const vm = env->vm;
	_jc_type *type;

	/* Check for null and get type */
	if (class == NULL) {
		_jc_post_exception(env, _JC_NullPointerException);
		_jc_throw_exception(env);
	}
	type = _jc_get_vm_pointer(class, vm->boot.fields.Class.vmdata);

	/* Look for class initializer */
	return _jc_get_declared_method(env, type, "<clinit>",
	    "()V", _JC_ACC_STATIC, _JC_ACC_STATIC) != NULL;
}

