
/*
 * Copyright (C) 2003-2005 Archie L. Cobbs and others.
 * All rights reserved.
 * 
 * This file is part of the JC virtual machine software.
 * 
 * JC is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License,
 * or (at your option) any later version.
 * 
 * JC is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General
 * Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with JC in the file "LGPL-2.1"; if not, write to:
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * $Id: verify.c,v 1.3 2005/02/27 04:52:59 archiecobbs Exp $
 */

#include "libjc.h"

/*
 * Verify a type.
 *
 * We don't verify yet. But note: this could be implemented in Java.
 *
 * NOTE: This assumes the caller is handling synchronization issues.
 */
jint
_jc_verify_type(_jc_env *env, _jc_type *type)
{
	/* Already verified? */
	if (_JC_FLG_TEST(type, VERIFIED)) {
		_JC_ASSERT(_JC_FLG_TEST(type, LOADED));
		return JNI_OK;
	}

	/* Sanity check */
	_JC_ASSERT(!_JC_FLG_TEST(type, ARRAY));

	/* XXX verify class here */

	/* Mark type as verified */
	type->flags |= _JC_TYPE_VERIFIED;

	/* Done */
	return JNI_OK;
}

