
/*
 * Copyright (C) 2003-2005 Archie L. Cobbs and others.
 * All rights reserved.
 * 
 * This file is part of the JC virtual machine software.
 * 
 * JC is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License,
 * or (at your option) any later version.
 * 
 * JC is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General
 * Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with JC in the file "LGPL-2.1"; if not, write to:
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * $Id: support.c,v 1.4 2005/03/12 04:24:54 archiecobbs Exp $
 */

#include "cfdump.h"

static _jc_class_loader	phoney_loader;
static _jc_env		phoney_env;
static _jc_jvm		phoney_jvm;

jboolean
_jc_interp_z(_jc_env *env, ...)
{
	return 0;
}

jbyte
_jc_interp_b(_jc_env *env, ...)
{
	return 0;
}

jchar
_jc_interp_c(_jc_env *env, ...)
{
	return 0;
}

jshort
_jc_interp_s(_jc_env *env, ...)
{
	return 0;
}

jint
_jc_interp_i(_jc_env *env, ...)
{
	return 0;
}

jlong
_jc_interp_j(_jc_env *env, ...)
{
	return 0;
}

jfloat
_jc_interp_f(_jc_env *env, ...)
{
	return 0;
}

jdouble
_jc_interp_d(_jc_env *env, ...)
{
	return 0;
}

_jc_object *
_jc_interp_l(_jc_env *env, ...)
{
	return NULL;
}

void
_jc_interp_v(_jc_env *env, ...)
{
}

jboolean
_jc_interp_native_z(_jc_env *env, ...)
{
	return 0;
}

jbyte
_jc_interp_native_b(_jc_env *env, ...)
{
	return 0;
}

jchar
_jc_interp_native_c(_jc_env *env, ...)
{
	return 0;
}

jshort
_jc_interp_native_s(_jc_env *env, ...)
{
	return 0;
}

jint
_jc_interp_native_i(_jc_env *env, ...)
{
	return 0;
}

jlong
_jc_interp_native_j(_jc_env *env, ...)
{
	return 0;
}

jfloat
_jc_interp_native_f(_jc_env *env, ...)
{
	return 0;
}

jdouble
_jc_interp_native_d(_jc_env *env, ...)
{
	return 0;
}

_jc_object *
_jc_interp_native_l(_jc_env *env, ...)
{
	return NULL;
}

void
_jc_interp_native_v(_jc_env *env, ...)
{
}

jint
_jc_gc(_jc_env *env, jboolean urgent)
{
	return JNI_OK;
}

_jc_env *
_jc_get_current_env()
{
	return &phoney_env;
}

_jc_env	*
_jc_support_init()
{
	_jc_mutex_init(&phoney_env, &phoney_loader.mutex);
	_jc_uni_alloc_init(&phoney_loader.uni, 0, NULL);
	phoney_jvm.boot.loader = &phoney_loader;
	phoney_env.vm = &phoney_jvm;
	return &phoney_env;
}

void
_jc_fatal_error(_jc_jvm *vm __attribute__ ((unused)), const char *fmt, ...)
{
	va_list args;

	va_start(args, fmt);
	vwarnx(fmt, args);
	va_end(args);
	abort();
}

void
_jc_post_exception(_jc_env *env, int num)
{
	_jc_post_exception_msg(env, num, NULL);
}

void
_jc_post_exception_info(_jc_env *env)
{
	_jc_post_exception_msg(env, env->ex.num,
	    *env->ex.msg != '\0' ? env->ex.msg : NULL);
}

_jc_object *
_jc_retrieve_exception(_jc_env *env, _jc_type *type)
{
	return NULL;
}

jboolean
_jc_unpost_exception(_jc_env *env, int num)
{
	return JNI_TRUE;
}

void
_jc_post_exception_msg(_jc_env *env __attribute__ ((unused)),
	int num, const char *fmt, ...)
{
	assert(0);
}

void
_jc_loader_wait(_jc_env *env, _jc_class_loader *loader)
{
}

