
/*
 * Copyright (C) 2003-2005 Archie L. Cobbs and others.
 * All rights reserved.
 * 
 * This file is part of the JC virtual machine software.
 * 
 * JC is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License,
 * or (at your option) any later version.
 * 
 * JC is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General
 * Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with JC in the file "LGPL-2.1"; if not, write to:
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * $Id: javah.h,v 1.1 2005/01/08 23:25:06 archiecobbs Exp $
 */

#ifndef _JAVAH_H_
#define _JAVAH_H_

#include "libjc.h"
#include <sys/param.h>
#include <err.h>
#include <assert.h>

#define EXCEPTION_MSG_MAX	128

extern int	exception;
extern char	exception_msg[EXCEPTION_MSG_MAX];

extern _jc_env		*_jc_support_init(void);

extern void		javah_header(_jc_classfile *cfile,
				const char *dir, jboolean jni);
extern void		javah_source(_jc_classfile *cfile,
				const char *dir, jboolean jni);
extern _jc_classbytes	*read_classbytes(_jc_env *env,
				const char *dir, const char *name);

#endif	/* _JAVAH_H_ */
