// public class soot.SootResolver

// class file dependencies
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 66aea4d152614ac4 java_io_InputStream
// @dep_class 99a46305ebacacb5 java_io_PrintStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 1f925cf50bfc0d6c java_lang_ClassNotFoundException
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class 6d7997e879c41059 java_util_AbstractSequentialList
// @dep_class ca427569b5b2f804 java_util_AbstractSet
// @dep_class d7cd853200c3e71f java_util_HashMap
// @dep_class 3c285c721478414d java_util_HashSet
// @dep_class be56ff673eefd9d2 java_util_Iterator
// @dep_class 666417b6279ae396 java_util_LinkedList
// @dep_class 9ee0d92ce1525a4d java_util_List
// @dep_class 617ac82c0bec2dff java_util_Set
// @dep_class 13e7935c8aaa97c9 soot_ArrayType
// @dep_class b6d33af8f84fdbc4 soot_G
// @dep_class 2887a1b57cecfb7b soot_RefType
// @dep_class 7120c8047949f8c0 soot_Scene
// @dep_class 6ac5bee50bbabb71 soot_Singletons
// @dep_class 634bd13ff2d8ac70 soot_SootClass
// @dep_class bd11c16680505218 soot_SootMethod
// @dep_class b4f2fa22d2f10a73 soot_SootResolver
// @dep_class f801e5c664424a1 soot_Type
// @dep_class cc9ea63544dd4229 soot_coffi_Util
// @dep_class 87cbc8ab1eddd109 soot_javaToJimple_InitialResolver
// @dep_class e5651dde6cd08af9 soot_jimple_ArithmeticConstant
// @dep_class a4a584ce60f6ce4 soot_jimple_Constant
// @dep_class fade60ef604ad800 soot_jimple_IntConstant
// @dep_class 468451bea5a857f5 soot_jimple_JimpleMethodSource
// @dep_class 3bd9379d3ff77f81 soot_jimple_NumericConstant
// @dep_class 12b5608acec0c8f9 soot_jimple_parser_CstPoolExtractor
// @dep_class b83f8dfa874c1604 soot_jimple_parser_JimpleAST
// @dep_class 90847822417adfa5 soot_jimple_parser_SkeletonExtractorWalker
// @dep_class b8af2571138d5c8f soot_jimple_parser_Walker
// @dep_class eda4e769c2cb49b3 soot_jimple_parser_analysis_Analysis
// @dep_class b43a9165b67db951 soot_jimple_parser_analysis_AnalysisAdapter
// @dep_class 49cf7a14fc836e70 soot_jimple_parser_analysis_DepthFirstAdapter
// @dep_class 8367d01c238d6542 soot_jimple_parser_node_Start
// @dep_class c5a5a246a3f59476 soot_options_Options
// @dep_class 26ddfd0bb4387ad soot_util_ClassInputStream
// @dep_class 5fcb4f89459205f2 soot_util_JavaInputStream
// @dep_class f39b2c829999c2fb soot_util_JimpleInputStream
// @dep_class be376690108f5fb9 soot_util_SourceLocator

// header file dependencies
// @dep_header java_io_IOException
// @dep_header java_io_PrintStream
// @dep_header java_lang_Class
// @dep_header java_lang_ClassNotFoundException
// @dep_header java_lang_RuntimeException
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_VMThrowable
// @dep_header java_util_HashMap
// @dep_header java_util_HashSet
// @dep_header java_util_Iterator
// @dep_header java_util_LinkedList
// @dep_header java_util_List
// @dep_header java_util_Set
// @dep_header soot_ArrayType
// @dep_header soot_G
// @dep_header soot_RefType
// @dep_header soot_Scene
// @dep_header soot_SootClass
// @dep_header soot_SootMethod
// @dep_header soot_SootResolver
// @dep_header soot_coffi_Util
// @dep_header soot_javaToJimple_InitialResolver
// @dep_header soot_jimple_IntConstant
// @dep_header soot_jimple_JimpleMethodSource
// @dep_header soot_jimple_parser_CstPoolExtractor
// @dep_header soot_jimple_parser_JimpleAST
// @dep_header soot_jimple_parser_SkeletonExtractorWalker
// @dep_header soot_jimple_parser_analysis_Analysis
// @dep_header soot_jimple_parser_node_Start
// @dep_header soot_options_Options
// @dep_header soot_util_ClassInputStream
// @dep_header soot_util_JavaInputStream
// @dep_header soot_util_JimpleInputStream
// @dep_header soot_util_SourceLocator

#include "jc_defs.h"

#include "java/io/IOException.h"
#include "java/io/PrintStream.h"
#include "java/lang/Class.h"
#include "java/lang/ClassNotFoundException.h"
#include "java/lang/RuntimeException.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/VMThrowable.h"
#include "java/util/HashMap.h"
#include "java/util/HashSet.h"
#include "java/util/Iterator.h"
#include "java/util/LinkedList.h"
#include "java/util/List.h"
#include "java/util/Set.h"
#include "soot/ArrayType.h"
#include "soot/G.h"
#include "soot/RefType.h"
#include "soot/Scene.h"
#include "soot/SootClass.h"
#include "soot/SootMethod.h"
#include "soot/SootResolver.h"
#include "soot/coffi/Util.h"
#include "soot/javaToJimple/InitialResolver.h"
#include "soot/jimple/IntConstant.h"
#include "soot/jimple/JimpleMethodSource.h"
#include "soot/jimple/parser/CstPoolExtractor.h"
#include "soot/jimple/parser/JimpleAST.h"
#include "soot/jimple/parser/SkeletonExtractorWalker.h"
#include "soot/jimple/parser/analysis/Analysis.h"
#include "soot/jimple/parser/node/Start.h"
#include "soot/options/Options.h"
#include "soot/util/ClassInputStream.h"
#include "soot/util/JavaInputStream.h"
#include "soot/util/JimpleInputStream.h"
#include "soot/util/SourceLocator.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private java.util.Set markedClasses
static _jc_field _jc_soot_SootResolver$field_info$markedClasses = {
	.name=		"markedClasses",
	.signature=	"Ljava/util/Set;",
	.class=		&_jc_soot_SootResolver$type,
	.type=		&_jc_java_util_Set$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_SootResolver$object, refs[-1].soot_SootResolver.markedClasses),
};

// private java.util.LinkedList classesToResolve
static _jc_field _jc_soot_SootResolver$field_info$classesToResolve = {
	.name=		"classesToResolve",
	.signature=	"Ljava/util/LinkedList;",
	.class=		&_jc_soot_SootResolver$type,
	.type=		&_jc_java_util_LinkedList$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_SootResolver$object, refs[-1].soot_SootResolver.classesToResolve),
};

// private boolean mIsResolving
static _jc_field _jc_soot_SootResolver$field_info$mIsResolving = {
	.name=		"mIsResolving",
	.signature=	"Z",
	.class=		&_jc_soot_SootResolver$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_SootResolver$object, nonrefs.soot_SootResolver.mIsResolving),
};

// private soot.javaToJimple.InitialResolver initSourceResolver
static _jc_field _jc_soot_SootResolver$field_info$initSourceResolver = {
	.name=		"initSourceResolver",
	.signature=	"Lsoot/javaToJimple/InitialResolver;",
	.class=		&_jc_soot_SootResolver$type,
	.type=		&_jc_soot_javaToJimple_InitialResolver$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_SootResolver$object, refs[-1].soot_SootResolver.initSourceResolver),
};

// Fields
static _jc_field *const _jc_soot_SootResolver$fields[] = {
	&_jc_soot_SootResolver$field_info$classesToResolve,
	&_jc_soot_SootResolver$field_info$initSourceResolver,
	&_jc_soot_SootResolver$field_info$markedClasses,
	&_jc_soot_SootResolver$field_info$mIsResolving
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>()
//

static _jc_linenum _jc_soot_SootResolver$linenum_table$_init$52f4ad9f2989aeee[];

static const unsigned char _jc_soot_SootResolver$param_ptypes$_init$52f4ad9f2989aeee[] = { 
_JC_TYPE_VOID };

_jc_method _jc_soot_SootResolver$method_info$_init$52f4ad9f2989aeee = {
	.name=			"<init>",
	.signature=		"()V",
	.class=			&_jc_soot_SootResolver$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_SootResolver$param_ptypes$_init$52f4ad9f2989aeee,
	.signature_hash=	_JC_JLONG(0x52f4ad9f2989aeee),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_SootResolver$method$_init$52f4ad9f2989aeee,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_soot_SootResolver$linenum_table$_init$52f4ad9f2989aeee
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_SootResolver, _init$52f4ad9f2989aeee);

void _JC_JCNI_ATTR
_jc_soot_SootResolver$method$_init$52f4ad9f2989aeee(_jc_env *const env, _jc_soot_SootResolver$object *this)
{
	struct _jc_soot_SootResolver$object *r0;
	struct _jc_java_util_HashSet$object *r1;
	struct _jc_java_util_LinkedList$object *r2;
	struct _jc_java_util_HashMap$object *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(41);				// 0
	r1 = _JC_NEW(env, java_util_HashSet);
	r5 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r5, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r1, java_util_HashSet, map) = r5;
	_JC_REF_FIELD(env, r0, soot_SootResolver, markedClasses) = r1;
	_JC_LINE_NUMBER(42);				// 1
	r2 = _JC_NEW(env, java_util_LinkedList);
	_JC_PRIM_FIELD(env, r2, java_util_LinkedList, size) = 0;
	_JC_REF_FIELD(env, r0, soot_SootResolver, classesToResolve) = r2;
	_JC_LINE_NUMBER(43);				// 2
	_JC_PRIM_FIELD(env, r0, soot_SootResolver, mIsResolving) = 0;
	_JC_LINE_NUMBER(49);				// 3
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public void assertResolvedClass(java.lang.String)
//

static _jc_linenum _jc_soot_SootResolver$linenum_table$assertResolvedClass$2803f63818d512a5[];

static const unsigned char _jc_soot_SootResolver$param_ptypes$assertResolvedClass$2803f63818d512a5[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_SootResolver$param_types$assertResolvedClass$2803f63818d512a5[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_soot_SootResolver$method_info$assertResolvedClass$2803f63818d512a5 = {
	.name=			"assertResolvedClass",
	.signature=		"(Ljava/lang/String;)V",
	.class=			&_jc_soot_SootResolver$type,
	.param_types=		&_jc_soot_SootResolver$param_types$assertResolvedClass$2803f63818d512a5,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_SootResolver$param_ptypes$assertResolvedClass$2803f63818d512a5,
	.signature_hash=	_JC_JLONG(0x2803f63818d512a5),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_SootResolver$method$assertResolvedClass$2803f63818d512a5,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_SootResolver$vtable, soot_SootResolver.assertResolvedClass$2803f63818d512a5) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_soot_SootResolver$linenum_table$assertResolvedClass$2803f63818d512a5
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_SootResolver, assertResolvedClass$2803f63818d512a5);

void _JC_JCNI_ATTR
_jc_soot_SootResolver$method$assertResolvedClass$2803f63818d512a5(_jc_env *const env, _jc_soot_SootResolver$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_soot_SootResolver$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_soot_SootClass$object *r2;
	struct _jc_object *r3;
	struct _jc_java_util_LinkedList$object *r4;
	struct _jc_soot_Scene$object *r5;
	struct _jc_soot_G$object *r6;
	struct _jc_soot_Scene$object *r8;
	struct _jc_soot_G$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_ACTIVE_USE(env, soot_Scene);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(164);				// 0
	r6 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r5 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r6);
	z0 = _JC_INVOKE_VIRTUAL(env, soot_Scene, containsClass$8d490286e66a732a, r5, r1);
	if (z0 != 0)
		goto label0;
	_JC_LINE_NUMBER(166);				// 1
	r2 = _JC_NEW(env, soot_SootClass);
	_JC_INVOKE_NONVIRTUAL(env, soot_SootClass, _init$8b03e78e1eb3b29e, 0, r2, r1, 0);
	_JC_LINE_NUMBER(167);				// 2
	r9 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r8 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r9);
	_JC_INVOKE_VIRTUAL(env, soot_Scene, addClass$505ab6b86e55da25, r8, r2);
	_JC_LINE_NUMBER(169);				// 3
	r3 = _JC_REF_FIELD(env, r0, soot_SootResolver, markedClasses);
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r2);
	_JC_LINE_NUMBER(170);				// 4
	r4 = _JC_REF_FIELD(env, r0, soot_SootResolver, classesToResolve);
	_JC_INVOKE_VIRTUAL(env, java_util_LinkedList, addLast$5d95154a1e0c521e, r4, r2);

label0:
	_JC_LINE_NUMBER(172);				// 5
	return;
}

//
// public void assertResolvedClassForType(soot.Type)
//

static _jc_linenum _jc_soot_SootResolver$linenum_table$assertResolvedClassForType$c94383438911b4d8[];

static const unsigned char _jc_soot_SootResolver$param_ptypes$assertResolvedClassForType$c94383438911b4d8[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_SootResolver$param_types$assertResolvedClassForType$c94383438911b4d8[] = {
	&_jc_soot_Type$type
};

_jc_method _jc_soot_SootResolver$method_info$assertResolvedClassForType$c94383438911b4d8 = {
	.name=			"assertResolvedClassForType",
	.signature=		"(Lsoot/Type;)V",
	.class=			&_jc_soot_SootResolver$type,
	.param_types=		&_jc_soot_SootResolver$param_types$assertResolvedClassForType$c94383438911b4d8,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_SootResolver$param_ptypes$assertResolvedClassForType$c94383438911b4d8,
	.signature_hash=	_JC_JLONG(0xc94383438911b4d8),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_SootResolver$method$assertResolvedClassForType$c94383438911b4d8,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_SootResolver$vtable, soot_SootResolver.assertResolvedClassForType$c94383438911b4d8) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_soot_SootResolver$linenum_table$assertResolvedClassForType$c94383438911b4d8
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_SootResolver, assertResolvedClassForType$c94383438911b4d8);

void _JC_JCNI_ATTR
_jc_soot_SootResolver$method$assertResolvedClassForType$c94383438911b4d8(_jc_env *const env, _jc_soot_SootResolver$object *this, _jc_soot_Type$object *param0)
{
	struct _jc_soot_SootResolver$object *r0;
	struct _jc_soot_Type$object *r1;
	struct _jc_soot_RefType$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_soot_ArrayType$object *r4;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(155);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_soot_RefType$type);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(156);				// 1
	r2 = r1;
	r3 = _JC_INVOKE_VIRTUAL(env, soot_RefType, getClassName$333433582f896913, r2);
	_JC_INVOKE_VIRTUAL(env, soot_SootResolver, assertResolvedClass$2803f63818d512a5, r0, r3);
	goto label1;

label0:
	_JC_LINE_NUMBER(157);				// 2
	z0 = _JC_INSTANCEOF(env, r1, &_jc_soot_ArrayType$type);
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(158);				// 3
	r4 = r1;
	r1 = _JC_REF_FIELD(env, r4, soot_ArrayType, baseType);
	_JC_INVOKE_VIRTUAL(env, soot_SootResolver, assertResolvedClassForType$c94383438911b4d8, r0, r1);

label1:
	_JC_LINE_NUMBER(159);				// 4
	return;
}

//
// public soot.SootClass getResolvedClass(java.lang.String)
//

static _jc_linenum _jc_soot_SootResolver$linenum_table$getResolvedClass$4e30830866f81476[];

static const unsigned char _jc_soot_SootResolver$param_ptypes$getResolvedClass$4e30830866f81476[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_soot_SootResolver$param_types$getResolvedClass$4e30830866f81476[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_soot_SootResolver$method_info$getResolvedClass$4e30830866f81476 = {
	.name=			"getResolvedClass",
	.signature=		"(Ljava/lang/String;)Lsoot/SootClass;",
	.class=			&_jc_soot_SootResolver$type,
	.param_types=		&_jc_soot_SootResolver$param_types$getResolvedClass$4e30830866f81476,
	.return_type=		&_jc_soot_SootClass$type,
	.param_ptypes=		&_jc_soot_SootResolver$param_ptypes$getResolvedClass$4e30830866f81476,
	.signature_hash=	_JC_JLONG(0x4e30830866f81476),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_SootResolver$method$getResolvedClass$4e30830866f81476,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_SootResolver$vtable, soot_SootResolver.getResolvedClass$4e30830866f81476) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	9,
	      .table=	_jc_soot_SootResolver$linenum_table$getResolvedClass$4e30830866f81476
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_SootResolver, getResolvedClass$4e30830866f81476);

_jc_soot_SootClass$object * _JC_JCNI_ATTR
_jc_soot_SootResolver$method$getResolvedClass$4e30830866f81476(_jc_env *const env, _jc_soot_SootResolver$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_soot_SootResolver$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_soot_Scene$object *r10;
	struct _jc_soot_G$object *r11;
	struct _jc_soot_SootClass$object *r2;
	struct _jc_object *r3;
	struct _jc_java_util_LinkedList$object *r4;
	struct _jc_soot_Scene$object *r5;
	struct _jc_soot_G$object *r6;
	struct _jc_soot_Scene$object *r7;
	struct _jc_soot_G$object *r8;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_ACTIVE_USE(env, soot_Scene);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(55);				// 0
	r6 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r5 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r6);
	z0 = _JC_INVOKE_VIRTUAL(env, soot_Scene, containsClass$8d490286e66a732a, r5, r1);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(56);				// 1
	r8 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r7 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r8);
	r2 = _JC_INVOKE_VIRTUAL(env, soot_Scene, getSootClass$9c5bf81fa0a8b0da, r7, r1);
	return r2;

label0:
	_JC_LINE_NUMBER(59);				// 2
	z0 = _JC_PRIM_FIELD(env, r0, soot_SootResolver, mIsResolving);
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(60);				// 3
	r2 = _JC_NEW(env, soot_SootClass);
	_JC_INVOKE_NONVIRTUAL(env, soot_SootClass, _init$8b03e78e1eb3b29e, 0, r2, r1, 0);
	_JC_LINE_NUMBER(61);				// 4
	r11 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r10 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r11);
	_JC_INVOKE_VIRTUAL(env, soot_Scene, addClass$505ab6b86e55da25, r10, r2);
	_JC_LINE_NUMBER(63);				// 5
	r3 = _JC_REF_FIELD(env, r0, soot_SootResolver, markedClasses);
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r2);
	_JC_LINE_NUMBER(64);				// 6
	r4 = _JC_REF_FIELD(env, r0, soot_SootResolver, classesToResolve);
	_JC_INVOKE_VIRTUAL(env, java_util_LinkedList, addLast$5d95154a1e0c521e, r4, r2);
	goto label2;

label1:
	_JC_LINE_NUMBER(66);				// 7
	r2 = _JC_INVOKE_VIRTUAL(env, soot_SootResolver, resolveClassAndSupportClasses$6bb947ad04a378f1, r0, r1);

label2:
	_JC_LINE_NUMBER(69);				// 8
	return r2;
}

//
// public soot.SootClass resolveClassAndSupportClasses(java.lang.String)
//

static _jc_linenum _jc_soot_SootResolver$linenum_table$resolveClassAndSupportClasses$6bb947ad04a378f1[];

static _jc_trap_info _jc_soot_SootResolver$trap_table$resolveClassAndSupportClasses$6bb947ad04a378f1[] = {
	_JC_TRAP(&_jc_java_lang_ClassNotFoundException$type, 1, 2),
	_JC_TRAP(&_jc_java_io_IOException$type, 3, 4),
};

static const unsigned char _jc_soot_SootResolver$param_ptypes$resolveClassAndSupportClasses$6bb947ad04a378f1[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_soot_SootResolver$param_types$resolveClassAndSupportClasses$6bb947ad04a378f1[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_soot_SootResolver$method_info$resolveClassAndSupportClasses$6bb947ad04a378f1 = {
	.name=			"resolveClassAndSupportClasses",
	.signature=		"(Ljava/lang/String;)Lsoot/SootClass;",
	.class=			&_jc_soot_SootResolver$type,
	.param_types=		&_jc_soot_SootResolver$param_types$resolveClassAndSupportClasses$6bb947ad04a378f1,
	.return_type=		&_jc_soot_SootClass$type,
	.param_ptypes=		&_jc_soot_SootResolver$param_ptypes$resolveClassAndSupportClasses$6bb947ad04a378f1,
	.signature_hash=	_JC_JLONG(0x6bb947ad04a378f1),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_SootResolver$method$resolveClassAndSupportClasses$6bb947ad04a378f1,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_SootResolver$vtable, soot_SootResolver.resolveClassAndSupportClasses$6bb947ad04a378f1) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_soot_SootResolver$trap_table$resolveClassAndSupportClasses$6bb947ad04a378f1,
	  .u= {
	    .linenum= {
	      .len=	42,
	      .table=	_jc_soot_SootResolver$linenum_table$resolveClassAndSupportClasses$6bb947ad04a378f1
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_SootResolver, resolveClassAndSupportClasses$6bb947ad04a378f1);

_jc_soot_SootClass$object * _JC_JCNI_ATTR
_jc_soot_SootResolver$method$resolveClassAndSupportClasses$6bb947ad04a378f1(_jc_env *const env, _jc_soot_SootResolver$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_soot_SootResolver$object *volatile r0;
	struct _jc_java_lang_String$object *volatile r1;
	struct _jc_java_util_LinkedList$object *volatile r10;
	struct _jc_java_lang_Object$object *volatile r11;
	struct _jc_java_io_InputStream$object *volatile r12;
	struct _jc_java_lang_RuntimeException$object *volatile r13;
	struct _jc_java_io_PrintStream$object *volatile r14;
	struct _jc_soot_util_JimpleInputStream$object *volatile r15;
	struct _jc_soot_javaToJimple_InitialResolver$object *volatile r16;
	struct _jc_object *volatile r17;
	struct _jc_java_io_IOException$object *r18;
	struct _jc_soot_G$object *volatile r19;
	struct _jc_soot_SootClass$object *volatile r2;
	struct _jc_soot_G$object *volatile r20;
	struct _jc_soot_G$object *volatile r21;
	struct _jc_java_lang_String$object *volatile r22;
	struct _jc_soot_G$object *volatile r23;
	struct _jc_java_lang_String$object *volatile r24;
	struct _jc_soot_util_SourceLocator$object *volatile r25;
	struct _jc_soot_G$object *volatile r26;
	struct _jc_soot_Scene$object *volatile r27;
	struct _jc_soot_G$object *volatile r28;
	struct _jc_java_lang_String$object *volatile r29;
	struct _jc_soot_SootClass$object *volatile r3;
	struct _jc_java_lang_String$object *volatile r30;
	struct _jc_soot_options_Options$object *volatile r31;
	struct _jc_soot_G$object *volatile r32;
	struct _jc_java_lang_String$object *volatile r33;
	struct _jc_soot_coffi_Util$object *volatile r34;
	struct _jc_soot_G$object *volatile r35;
	struct _jc_soot_Scene$object *volatile r36;
	struct _jc_soot_G$object *volatile r37;
	struct _jc_soot_options_Options$object *volatile r38;
	struct _jc_soot_G$object *volatile r39;
	struct _jc_java_lang_ClassNotFoundException$object *r4;
	struct _jc_java_lang_String$object *volatile r40;
	struct _jc_soot_options_Options$object *volatile r41;
	struct _jc_soot_G$object *volatile r42;
	struct _jc_java_lang_String$object *volatile r43;
	struct _jc_soot_util_SourceLocator$object *volatile r44;
	struct _jc_soot_G$object *volatile r45;
	struct _jc_soot_util_SourceLocator$object *volatile r46;
	struct _jc_soot_G$object *volatile r47;
	struct _jc_java_lang_String$object *volatile r48;
	_jc_char_array *volatile r49;
	struct _jc_java_lang_StringBuffer$object *volatile r5;
	_jc_char_array *volatile r50;
	_jc_char_array *volatile r51;
	_jc_char_array *volatile r52;
	_jc_char_array *volatile r53;
	_jc_char_array *volatile r54;
	struct _jc_java_lang_VMThrowable$object *volatile r55;
	struct _jc_java_lang_VMThrowable$object *volatile r56;
	struct _jc_java_lang_VMThrowable$object *volatile r57;
	struct _jc_java_lang_VMThrowable$object *volatile r58;
	struct _jc_soot_jimple_parser_CstPoolExtractor$object *volatile r59;
	struct _jc_soot_jimple_parser_JimpleAST$object *volatile r6;
	struct _jc_soot_jimple_parser_node_Start$object *volatile r60;
	struct _jc_object *volatile r61;
	struct _jc_java_lang_StringBuffer$object *volatile r62;
	struct _jc_java_lang_String$object *volatile r63;
	struct _jc_soot_jimple_parser_SkeletonExtractorWalker$object *volatile r64;
	struct _jc_soot_SootResolver$object *volatile r65;
	struct _jc_soot_jimple_parser_node_Start$object *volatile r66;
	struct _jc_object *volatile r67;
	struct _jc_java_util_LinkedList$object *volatile r68;
	struct _jc_soot_jimple_IntConstant$object *volatile r69;
	struct _jc_soot_jimple_JimpleMethodSource$object *volatile r7;
	struct _jc_object *volatile r8;
	struct _jc_soot_SootMethod$object *volatile r9;
	jboolean volatile z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_soot_SootResolver$method_info$resolveClassAndSupportClasses$6bb947ad04a378f1, &&label1, &&label18);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(77);				// 0
	_JC_PRIM_FIELD(env, r0, soot_SootResolver, mIsResolving) = 1;
	_JC_LINE_NUMBER(78);				// 1
	r2 = _JC_INVOKE_VIRTUAL(env, soot_SootResolver, getResolvedClass$4e30830866f81476, r0, r1);

label0:
	_JC_TRAP_REGION(catch, 0);
	_JC_LINE_NUMBER(80);				// 2
	r10 = _JC_REF_FIELD(env, r0, soot_SootResolver, classesToResolve);
	z0 = _JC_INVOKE_VIRTUAL(env, java_util_AbstractCollection, isEmpty$551bea84f4e0f0cb, r10);
	if (z0 != 0)
		goto label19;
	_JC_LINE_NUMBER(83);				// 3
	r10 = _JC_REF_FIELD(env, r0, soot_SootResolver, classesToResolve);
	r11 = _JC_INVOKE_VIRTUAL(env, java_util_LinkedList, removeFirst$539049aa2de97f0d, r10);
	r3 = _JC_CAST(env, &_jc_soot_SootClass$type, r11);
	_JC_LINE_NUMBER(84);				// 4
	r1 = _JC_INVOKE_VIRTUAL(env, soot_SootClass, getName$bec186f2ce7e1882, r3);
	_JC_TRAP_REGION(catch, 1);
	_JC_ACTIVE_USE(env, soot_util_SourceLocator);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(88);				// 5
	r26 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r25 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, SourceLocator$62e31a58183d70d3, r26);
	r12 = _JC_INVOKE_VIRTUAL(env, soot_util_SourceLocator, getInputStreamOf$3620343256421670, r25, r1);
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(99);				// 6
	goto label3;

label1:
	_JC_TRAP_REGION(catch, 2);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_ACTIVE_USE(env, soot_Scene);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(91);				// 7
	r28 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r27 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r28);
	z0 = _JC_INVOKE_VIRTUAL(env, soot_Scene, allowsPhantomRefs$699bc9d650a68f01, r27);
	if (z0 != 0)
		goto label2;
	_JC_LINE_NUMBER(92);				// 8
	r13 = _JC_NEW(env, java_lang_RuntimeException);
	r5 = _JC_NEW(env, java_lang_StringBuffer);
	r49 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r5, java_lang_StringBuffer, value) = r49;
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, _JC_STRING(env, "couldn't find type: "));
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, r1);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, _JC_STRING(env, " (is your soot-class-path set properly?)"));
	r29 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r29, r5);
	_JC_REF_FIELD(env, r13, java_lang_Throwable, cause) = r13;
	r55 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r13);
	_JC_REF_FIELD(env, r13, java_lang_Throwable, vmState) = r55;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, detailMessage) = r29;
	_JC_THROW(env, r13);

label2:
	_JC_LINE_NUMBER(95);				// 9
	r19 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r14 = _JC_REF_FIELD(env, r19, soot_G, out);
	r5 = _JC_NEW(env, java_lang_StringBuffer);
	r50 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r5, java_lang_StringBuffer, value) = r50;
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, _JC_STRING(env, "Warning: "));
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, r1);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, _JC_STRING(env, " is a phantom class!"));
	r30 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r30, r5);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r14, r30);
	_JC_LINE_NUMBER(96);				// 10
	_JC_INVOKE_VIRTUAL(env, soot_SootClass, setPhantomClass$851943289b7cb20a, r3);
	_JC_LINE_NUMBER(97);				// 11
	_JC_PERIODIC_CHECK(env);
	goto label0;

label3:
	_JC_LINE_NUMBER(102);				// 12
	z0 = _JC_INSTANCEOF(env, r12, &_jc_soot_util_ClassInputStream$type);
	if (z0 == 0)
		goto label5;
	_JC_ACTIVE_USE(env, soot_options_Options);
	_JC_LINE_NUMBER(103);				// 13
	r32 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r31 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Options$9fd4168abe5957f7, r32);
	z0 = _JC_INVOKE_VIRTUAL(env, soot_options_Options, verbose$e5b65d4727121643, r31);
	if (z0 == 0)
		goto label4;
	_JC_LINE_NUMBER(104);				// 14
	r20 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r14 = _JC_REF_FIELD(env, r20, soot_G, out);
	r5 = _JC_NEW(env, java_lang_StringBuffer);
	r51 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r5, java_lang_StringBuffer, value) = r51;
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, _JC_STRING(env, "resolving [from .class]: "));
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, r1);
	r33 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r33, r5);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r14, r33);

label4:
	_JC_ACTIVE_USE(env, soot_coffi_Util);
	_JC_LINE_NUMBER(105);				// 15
	r35 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r34 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Util$06cb205633d5217b, r35);
	_JC_ACTIVE_USE(env, soot_Scene);
	r37 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r36 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r37);
	_JC_INVOKE_VIRTUAL(env, soot_coffi_Util, resolveFromClassFile$b62234b7f6f6b4c0, r34, r3, r12, r0, r36);
	goto label17;

label5:
	_JC_LINE_NUMBER(106);				// 16
	z0 = _JC_INSTANCEOF(env, r12, &_jc_soot_util_JimpleInputStream$type);
	if (z0 == 0)
		goto label11;
	_JC_ACTIVE_USE(env, soot_options_Options);
	_JC_LINE_NUMBER(107);				// 17
	r39 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r38 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Options$9fd4168abe5957f7, r39);
	z0 = _JC_INVOKE_VIRTUAL(env, soot_options_Options, verbose$e5b65d4727121643, r38);
	if (z0 == 0)
		goto label6;
	_JC_LINE_NUMBER(108);				// 18
	r21 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r14 = _JC_REF_FIELD(env, r21, soot_G, out);
	r5 = _JC_NEW(env, java_lang_StringBuffer);
	r52 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r5, java_lang_StringBuffer, value) = r52;
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, _JC_STRING(env, "resolving [from .jimple]: "));
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, r1);
	r40 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r40, r5);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r14, r40);

label6:
	_JC_LINE_NUMBER(109);				// 19
	if (r3 != _JC_NULL)
		goto label7;
	r13 = _JC_NEW(env, java_lang_RuntimeException);
	r22 = _JC_STRING(env, "sc is null!!");
	_JC_REF_FIELD(env, r13, java_lang_Throwable, cause) = r13;
	r56 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r13);
	_JC_REF_FIELD(env, r13, java_lang_Throwable, vmState) = r56;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, detailMessage) = r22;
	_JC_THROW(env, r13);

label7:
	_JC_LINE_NUMBER(111);				// 20
	r6 = _JC_NEW(env, soot_jimple_parser_JimpleAST);
	r15 = r12;
	_JC_INVOKE_NONVIRTUAL(env, soot_jimple_parser_JimpleAST, _init$1a0473984dd4f3ce, 0, r6, r15, r0);
	r64 = _JC_NEW(env, soot_jimple_parser_SkeletonExtractorWalker);
	r65 = _JC_REF_FIELD(env, r6, soot_jimple_parser_JimpleAST, mResolver);
	_JC_PRIM_FIELD(env, r64, soot_jimple_parser_Walker, debug) = 0;
	r68 = _JC_NEW(env, java_util_LinkedList);
	_JC_PRIM_FIELD(env, r68, java_util_LinkedList, size) = 0;
	_JC_REF_FIELD(env, r64, soot_jimple_parser_Walker, mProductions) = r68;
	_JC_REF_FIELD(env, r64, soot_jimple_parser_Walker, mSootClass) = _JC_NULL;
	_JC_REF_FIELD(env, r64, soot_jimple_parser_Walker, mLocals) = _JC_NULL;
	_JC_ACTIVE_USE(env, soot_jimple_IntConstant);
	r69 = _JC_NEW(env, soot_jimple_IntConstant);
	_JC_PRIM_FIELD(env, r69, soot_jimple_IntConstant, value) = 1;
	_JC_REF_FIELD(env, r64, soot_jimple_parser_Walker, mValue) = r69;
	_JC_REF_FIELD(env, r64, soot_jimple_parser_Walker, mSootClass) = r3;
	_JC_REF_FIELD(env, r64, soot_jimple_parser_Walker, mResolver) = r65;
	r66 = _JC_REF_FIELD(env, r6, soot_jimple_parser_JimpleAST, mTree);
	_JC_EXPLICIT_NULL_CHECK(env, r66);
	r67 = r64;
	_JC_INVOKE_INTERFACE(env, r67, _JC_JLONG(0x54431c76f01c85df), void, (_jc_env *, struct _jc_object *, struct _jc_soot_jimple_parser_node_Start$object *), r66);
	_JC_LINE_NUMBER(113);				// 21
	r7 = _JC_NEW(env, soot_jimple_JimpleMethodSource);
	_JC_REF_FIELD(env, r7, soot_jimple_JimpleMethodSource, mJimpleAST) = r6;
	_JC_LINE_NUMBER(115);				// 22
	r8 = _JC_INVOKE_VIRTUAL(env, soot_SootClass, methodIterator$685c73a73d0b4550, r3);

label8:
	_JC_LINE_NUMBER(116);				// 23
	z0 = _JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label9;
	_JC_LINE_NUMBER(117);				// 24
	r11 = _JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r9 = _JC_CAST(env, &_jc_soot_SootMethod$type, r11);
	_JC_LINE_NUMBER(118);				// 25
	_JC_INVOKE_VIRTUAL(env, soot_SootMethod, setSource$c5c1629bce14f90e, r9, r7);
	_JC_PERIODIC_CHECK(env);
	goto label8;

label9:
	r59 = _JC_NEW(env, soot_jimple_parser_CstPoolExtractor);
	r60 = _JC_REF_FIELD(env, r6, soot_jimple_parser_JimpleAST, mTree);
	_JC_REF_FIELD(env, r59, soot_jimple_parser_CstPoolExtractor, mRefTypes) = _JC_NULL;
	_JC_REF_FIELD(env, r59, soot_jimple_parser_CstPoolExtractor, mParseTree) = r60;
	r61 = _JC_INVOKE_NONVIRTUAL(env, soot_jimple_parser_CstPoolExtractor, getCstPool$8a0a764b08f60ae5, 0, r59);
	_JC_LINE_NUMBER(121);				// 26
	r8 = _JC_INVOKE_INTERFACE(env, r61, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label10:
	_JC_LINE_NUMBER(122);				// 27
	z0 = _JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label17;
	_JC_LINE_NUMBER(123);				// 28
	r11 = _JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r1 = _JC_CAST_FINAL(env, &_jc_java_lang_String$type, r11);
	_JC_LINE_NUMBER(124);				// 29
	_JC_INVOKE_VIRTUAL(env, soot_SootResolver, assertResolvedClass$2803f63818d512a5, r0, r1);
	_JC_PERIODIC_CHECK(env);
	goto label10;

label11:
	_JC_LINE_NUMBER(127);				// 30
	z0 = _JC_INSTANCEOF(env, r12, &_jc_soot_util_JavaInputStream$type);
	if (z0 == 0)
		goto label14;
	_JC_ACTIVE_USE(env, soot_options_Options);
	_JC_LINE_NUMBER(128);				// 31
	r42 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r41 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Options$9fd4168abe5957f7, r42);
	z0 = _JC_INVOKE_VIRTUAL(env, soot_options_Options, verbose$e5b65d4727121643, r41);
	if (z0 == 0)
		goto label12;
	_JC_LINE_NUMBER(129);				// 32
	r23 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r14 = _JC_REF_FIELD(env, r23, soot_G, out);
	r5 = _JC_NEW(env, java_lang_StringBuffer);
	r53 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r5, java_lang_StringBuffer, value) = r53;
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, _JC_STRING(env, "resolving [from .java]: "));
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, r1);
	r43 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r43, r5);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r14, r43);

label12:
	_JC_LINE_NUMBER(132);				// 33
	r16 = _JC_REF_FIELD(env, r0, soot_SootResolver, initSourceResolver);
	if (r16 != _JC_NULL)
		goto label13;
	_JC_LINE_NUMBER(133);				// 34
	r16 = _JC_NEW(env, soot_javaToJimple_InitialResolver);
	_JC_PRIM_FIELD(env, r16, soot_javaToJimple_InitialResolver, privateAccessCounter) = 0;
	_JC_REF_FIELD(env, r0, soot_SootResolver, initSourceResolver) = r16;

label13:
	_JC_LINE_NUMBER(135);				// 35
	r16 = _JC_REF_FIELD(env, r0, soot_SootResolver, initSourceResolver);
	r45 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r44 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, SourceLocator$62e31a58183d70d3, r45);
	r1 = _JC_INVOKE_VIRTUAL(env, soot_util_SourceLocator, getFullPathFound$72ac8e99a6a17dd7, r44);
	r47 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r46 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, SourceLocator$62e31a58183d70d3, r47);
	r17 = _JC_INVOKE_VIRTUAL(env, soot_util_SourceLocator, getLocationsFound$ec926b3c963215c8, r46);
	_JC_INVOKE_VIRTUAL(env, soot_javaToJimple_InitialResolver, formAst$8ab4d7486758364b, r16, r1, r17);
	_JC_LINE_NUMBER(136);				// 36
	r16 = _JC_REF_FIELD(env, r0, soot_SootResolver, initSourceResolver);
	_JC_INVOKE_VIRTUAL(env, soot_javaToJimple_InitialResolver, resolveFromJavaFile$9e95f7cedcd000a2, r16, r3, r0);
	goto label17;

label14:
	_JC_LINE_NUMBER(139);				// 37
	r13 = _JC_NEW(env, java_lang_RuntimeException);
	r5 = _JC_NEW(env, java_lang_StringBuffer);
	r54 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r5, java_lang_StringBuffer, value) = r54;
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, _JC_STRING(env, "could not resolve class: "));
	r62 = r5;
	if (r12 != _JC_NULL)
		goto label15;
	r63 = _JC_STRING(env, "null");
	goto label16;

label15:
	r63 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r12);

label16:
	r62 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r62, r63);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r62, _JC_STRING(env, " (is your soot-class-path correct?)"));
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	r48 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r48, r5);
	_JC_REF_FIELD(env, r13, java_lang_Throwable, cause) = r13;
	r57 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r13);
	_JC_REF_FIELD(env, r13, java_lang_Throwable, vmState) = r57;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, detailMessage) = r48;
	_JC_THROW(env, r13);

label17:
	_JC_TRAP_REGION(catch, 3);
	_JC_LINE_NUMBER(143);				// 38
	_JC_INVOKE_VIRTUAL(env, java_io_InputStream, close$6aba8b329fddcd79, r12);
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(145);				// 39
	_JC_PERIODIC_CHECK(env);
	goto label0;

label18:
	_JC_TRAP_REGION(catch, 4);
	r18 = _JC_CAUGHT_EXCEPTION(env);
	r13 = _JC_NEW(env, java_lang_RuntimeException);
	r24 = _JC_STRING(env, "!?");
	_JC_REF_FIELD(env, r13, java_lang_Throwable, cause) = r13;
	r58 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r13);
	_JC_REF_FIELD(env, r13, java_lang_Throwable, vmState) = r58;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, detailMessage) = r24;
	_JC_THROW(env, r13);

label19:
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(148);				// 40
	_JC_PRIM_FIELD(env, r0, soot_SootResolver, mIsResolving) = 0;
	_JC_LINE_NUMBER(149);				// 41
	_JC_CANCEL_TRAPS(env, catch);
	return r2;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_soot_SootResolver$methods[] = {
	&_jc_soot_SootResolver$method_info$_init$52f4ad9f2989aeee,
	&_jc_soot_SootResolver$method_info$assertResolvedClass$2803f63818d512a5,
	&_jc_soot_SootResolver$method_info$assertResolvedClassForType$c94383438911b4d8,
	&_jc_soot_SootResolver$method_info$getResolvedClass$4e30830866f81476,
	&_jc_soot_SootResolver$method_info$resolveClassAndSupportClasses$6bb947ad04a378f1
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_soot_SootResolver$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_SootResolver$instanceof_hash_bucket_115[] = {
	&_jc_soot_SootResolver$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_soot_SootResolver$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[101]=	_jc_soot_SootResolver$instanceof_hash_bucket_101,
	[115]=	_jc_soot_SootResolver$instanceof_hash_bucket_115
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_soot_SootResolver$class_depends[] = {
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/InputStream",	_JC_JLONG(0x66aea4d152614ac4) },
	{ "java/io/PrintStream",	_JC_JLONG(0x99a46305ebacacb5) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassNotFoundException",	_JC_JLONG(0x1f925cf50bfc0d6c) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/AbstractSequentialList",	_JC_JLONG(0x6d7997e879c41059) },
	{ "java/util/AbstractSet",	_JC_JLONG(0xca427569b5b2f804) },
	{ "java/util/HashMap",	_JC_JLONG(0xd7cd853200c3e71f) },
	{ "java/util/HashSet",	_JC_JLONG(0x3c285c721478414d) },
	{ "java/util/Iterator",	_JC_JLONG(0xbe56ff673eefd9d2) },
	{ "java/util/LinkedList",	_JC_JLONG(0x666417b6279ae396) },
	{ "java/util/List",	_JC_JLONG(0x9ee0d92ce1525a4d) },
	{ "java/util/Set",	_JC_JLONG(0x617ac82c0bec2dff) },
	{ "soot/ArrayType",	_JC_JLONG(0x13e7935c8aaa97c9) },
	{ "soot/G",	_JC_JLONG(0xb6d33af8f84fdbc4) },
	{ "soot/RefType",	_JC_JLONG(0x2887a1b57cecfb7b) },
	{ "soot/Scene",	_JC_JLONG(0x7120c8047949f8c0) },
	{ "soot/Singletons",	_JC_JLONG(0x6ac5bee50bbabb71) },
	{ "soot/SootClass",	_JC_JLONG(0x634bd13ff2d8ac70) },
	{ "soot/SootMethod",	_JC_JLONG(0xbd11c16680505218) },
	{ "soot/Type",	_JC_JLONG(0xf801e5c664424a1) },
	{ "soot/coffi/Util",	_JC_JLONG(0xcc9ea63544dd4229) },
	{ "soot/javaToJimple/InitialResolver",	_JC_JLONG(0x87cbc8ab1eddd109) },
	{ "soot/jimple/ArithmeticConstant",	_JC_JLONG(0xe5651dde6cd08af9) },
	{ "soot/jimple/Constant",	_JC_JLONG(0xa4a584ce60f6ce4) },
	{ "soot/jimple/IntConstant",	_JC_JLONG(0xfade60ef604ad800) },
	{ "soot/jimple/JimpleMethodSource",	_JC_JLONG(0x468451bea5a857f5) },
	{ "soot/jimple/NumericConstant",	_JC_JLONG(0x3bd9379d3ff77f81) },
	{ "soot/jimple/parser/CstPoolExtractor",	_JC_JLONG(0x12b5608acec0c8f9) },
	{ "soot/jimple/parser/JimpleAST",	_JC_JLONG(0xb83f8dfa874c1604) },
	{ "soot/jimple/parser/SkeletonExtractorWalker",	_JC_JLONG(0x90847822417adfa5) },
	{ "soot/jimple/parser/Walker",	_JC_JLONG(0xb8af2571138d5c8f) },
	{ "soot/jimple/parser/analysis/Analysis",	_JC_JLONG(0xeda4e769c2cb49b3) },
	{ "soot/jimple/parser/analysis/AnalysisAdapter",	_JC_JLONG(0xb43a9165b67db951) },
	{ "soot/jimple/parser/analysis/DepthFirstAdapter",	_JC_JLONG(0x49cf7a14fc836e70) },
	{ "soot/jimple/parser/node/Start",	_JC_JLONG(0x8367d01c238d6542) },
	{ "soot/options/Options",	_JC_JLONG(0xc5a5a246a3f59476) },
	{ "soot/util/ClassInputStream",	_JC_JLONG(0x26ddfd0bb4387ad) },
	{ "soot/util/JavaInputStream",	_JC_JLONG(0x5fcb4f89459205f2) },
	{ "soot/util/JimpleInputStream",	_JC_JLONG(0xf39b2c829999c2fb) },
	{ "soot/util/SourceLocator",	_JC_JLONG(0xbe376690108f5fb9) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_soot_SootResolver$vtype _jc_soot_SootResolver$type = {
    .type= {
	.name=			"soot/SootResolver",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		15,
		.hash=			_JC_JLONG(0xb4f2fa22d2f10a73),
		.source_file=		"SootResolver.java",
		.instance_size=		sizeof(_jc_soot_SootResolver$refs) + sizeof(_jc_soot_SootResolver$object),
		.num_virtual_refs=	3,
		.num_fields=		sizeof(_jc_soot_SootResolver$fields) / sizeof(*_jc_soot_SootResolver$fields),
		.fields=		_jc_soot_SootResolver$fields,
		.num_methods=		sizeof(_jc_soot_SootResolver$methods) / sizeof(*_jc_soot_SootResolver$methods),
		.methods=		_jc_soot_SootResolver$methods,
		.instanceof_hash_table=	_jc_soot_SootResolver$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_soot_SootResolver$class_depends) / sizeof(*_jc_soot_SootResolver$class_depends),
		.class_depends=		_jc_soot_SootResolver$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.soot_SootResolver= {
	    .assertResolvedClass$2803f63818d512a5=
		&_jc_soot_SootResolver$method$assertResolvedClass$2803f63818d512a5,
	    .assertResolvedClassForType$c94383438911b4d8=
		&_jc_soot_SootResolver$method$assertResolvedClassForType$c94383438911b4d8,
	    .getResolvedClass$4e30830866f81476=
		&_jc_soot_SootResolver$method$getResolvedClass$4e30830866f81476,
	    .resolveClassAndSupportClasses$6bb947ad04a378f1=
		&_jc_soot_SootResolver$method$resolveClassAndSupportClasses$6bb947ad04a378f1,
	},
    }
};

